/*--------------------------------------------------------------+
| Author: Daniel Porumbel 2018                                  |
|License: Creative Commons Attribution 3.0 Unported License     |
|         http://creativecommons.org/licenses/by/3.0/           |             
+--------------------------------------------------------------*/
#ifndef TABUSEARCH_H
#define TABUSEARCH_H
extern int**   edge;           //These global variables simply define the graph:
extern int     n;              //vtx no
extern int     m;              //edge no
extern int     k;              //cluster size
extern double**ww;             //weight of edge[i][j]: 1 if {i,j}\in V, 0 otherwise
extern int objMaxPossible;     //maximum number of edges in a k-clique
#define INFTY_RADIUS_NO_DISTS (100*::n)


void readGraph(char*filename);

//Allocate variables for TS, e.g., fill the table of edge weights (1 if edge, else 0 
//by default). Does nothing if table tabu is non-null.
void allocGlobalsTabuSearch();

//Free memory for Tabu Search
void freeGlobalsTabuSearch();

//Start a TS run (segment) from center to find max ww-weighted cluster of size k (k vertices)
//stop when reaching maxIter or when reaching distance maxRadius from center
//Write best visited cluster in solbest, 
//Consider edge weights ww, some of them may be very negative (missing edge)
double tabuSearchSegment(int* solbest, int& itersElapsed,                    //output
                         int* center, int itersLeft, int maxRadius);         //input
#endif
